local db
local a = CreateFrame("Frame")
local _G = getfenv(0)
local data = {
	enabled = true,
	filter = {},
	ignore = {},
}
local printf = function(str, ...)
	str = string.format(str, ...)
	ChatFrame1:AddMessage("|cffFF0099GetVendored|r: "..str)
end
local print = function(...)
	local text = ""
	if select("#", ...) > 1 then
		for i = 1,select("#", ...) do
			text = text.." "..tostring(select(i, ...))
		end
	else
		text = tostring(select(1, ...))
	end
	ChatFrame1:AddMessage("|cffFF0099GetVendored|r: "..text)
end
local initdb = function()
	local name,realm = UnitName("player"), GetRealmName()
	db = _G.GetVendoredDB
	if not db then
		db = {
			[realm] = {
				[name] = data
			},
		}
		_G.GetVendoredDB = db
	end
	if not db[realm] then
		db[realm] = {
			[name] = data
		}
	end
	if not db[realm][name] then
		db[realm][name] = data
	end
	db = db[realm][name]
end
a.MERCHANT_SHOW = function()
	if not db.enabled then return end
	for bag = 0,4 do
		for slot = 1,GetContainerNumSlots(bag) do
			local itemlink = GetContainerItemLink(bag, slot)
			if itemlink then
				if (select(3, GetItemInfo(itemlink)) == 0 or db.filter[GetItemInfo(itemlink)]) and not db.ignore[GetItemInfo(itemlink)] then
					UseContainerItem(bag, slot)
				end
			end
		end
	end
end
a.ADDON_LOADED = function(event, ...)
	if arg1 == "GetVendored" then
		initdb()
	end
end
a:SetScript("OnEvent", function(self, event, ...)
	self[event](event, ...)
end)
a:RegisterEvent("MERCHANT_SHOW")
a:RegisterEvent("ADDON_LOADED")
SLASH_GETVENDORED1 = "/gv"
SlashCmdList.GETVENDORED = function(s)
	local cmd,rest = s:match("%s*(%S+)%s*(.*)$")
	rest = strtrim(rest)
	local handle = cmd and a["CMD_"..cmd:upper()]
	if handle then
		handle(rest)
	else
		print("GetVendored - Simple vendoring shizzle")
		print("Commands:")
		print("         junk: Add or removes an item to the junk filter")
		print("         ignore: Add or removes an item to the ignore filter")
		print("         list: Lits items in the specified filter")
		print("         clear: Clears a filter list or whole db")
		print("         enable: toggles enable")
	end
end
a.CMD_JUNK = function(cmd)
	local itemname = GetItemInfo(cmd)
	if not db.filter[itemname] then
		db.filter[itemname] = true
		printf("Added %s to the filter list", itemname)
	else
		db.filter[itemname] = nil
		printf("Removed %s from the the filter", itemname)
	end
end
a.CMD_IGNORE = function(cmd)
	local itemname = GetItemInfo(cmd)
	if not db.ignore[itemname] then
		db.ignore[itemname] = true
		printf("Added %s to the ignore list", itemname)
	else
		db.ignore[itemname] = nil
		printf("Removed %s to the ignore list", itemname)
	end
end
a.CMD_CLEAR = function(cmd)
	if db[cmd] then
		for k,v in pairs(db[cmd]) do
			k = nil
		end
		printf("%s cleared", db[cmd])
	elseif cmd:upper() == "DB" then
		for k,v in pairs(db) do
			k = nil
		end
		print("db reset")
	else
		print("tables: filter, ignore or your chars DB")
	end
end
a.CMD_LIST = function(cmd)
	if db[cmd] then
		print("Current items in: "..cmd)
		for k,v in pairs(db[cmd]) do
			print(k)
		end
	else
		print(cmd.." Does'nt exist")
	end
end
a.CMD_ENABLE = function(cmd)
	db.enabled = not db.enabled
	if db.enabled then
		print("Enabled")
	else
		print("Disabled")
	end
end
